using Indotalent.Infrastructure.Database;
using MediatR;
using Microsoft.EntityFrameworkCore;

namespace Indotalent.Features.Inventory.NegativeAdjustment.Cqrs;

public record DeleteNegativeAdjustmentItemCommand(string Id) : IRequest<bool>;

public class DeleteNegativeAdjustmentItemHandler : IRequestHandler<DeleteNegativeAdjustmentItemCommand, bool>
{
    private readonly AppDbContext _context;
    public DeleteNegativeAdjustmentItemHandler(AppDbContext context) => _context = context;

    public async Task<bool> Handle(DeleteNegativeAdjustmentItemCommand request, CancellationToken cancellationToken)
    {
        var entity = await _context.InventoryTransaction
            .FirstOrDefaultAsync(x => x.Id == request.Id, cancellationToken);

        if (entity == null) return false;

        _context.InventoryTransaction.Remove(entity);
        await _context.SaveChangesAsync(cancellationToken);

        return true;
    }
}